/* Router solicitation program.  Standalone.
   Does not require link-layer indications */


/*************************************************************/
/*
Please note that either this license MUST be displayed
or a particular instance of this code may be converted to
the GNU General Public License v2 or greater.

Please see README.txt for details.
*/

/*
Copyright (c) 2005, Monash University
All rights reserved.
Contributors: Greg Daley

Redistribution and use in source and binary forms, with or
without modification, are permitted provided that the following
conditions are met:

* Redistributions of source code must retain the above copyright
  notice, this list of conditions and the following disclaimer.

* Redistributions in binary form must reproduce the above
  copyright notice, this list of conditions and the following
  disclaimer in the documentation and/or other materials
  provided with the distribution.

* Neither the name of Monash University nor the names of its
  contributors may be used to endorse or promote products derived
  from this software without specific prior written permission.

THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS
"AS IS" AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT
LIMITED TO, THE IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS
FOR A PARTICULAR PURPOSE ARE DISCLAIMED. IN NO NTLINK SHALL THE
COPYRIGHT OWNER OR CONTRIBUTORS BE LIABLE FOR ANY DIRECT, INDIRECT,
INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL DAMAGES (INCLUDING,
BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS OR SERVICES;
LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION) HOWEVER
CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY
WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE
POSSIBILITY OF SUCH DAMAGE.
 
*/
/*************************************************************/


#ifndef DNA_H
#define DNA_H

#include <sys/types.h>

#ifndef MAX_RTR_SOLICITATIONS
#define MAX_RTR_SOLICITATIONS  3 
#endif 


#ifndef RTR_SOLICITATION_INTERVAL
#define RTR_SOLICITATION_INTERVAL 4 /* seconds */
#endif 

#ifndef ND_OPT_TENTATIVE_SLLA
#define ND_OPT_TENTATIVE_SLLA     0x11
#endif  /* ND_OPT_TENTATIVE_SLLA */

#ifndef ND_OPT_LANDMARK
#define ND_OPT_LANDMARK 0x13

struct nd_opt_landmark{
        uint8_t  nd_opt_landmark_type;
        uint8_t  nd_opt_landmark_len;
        uint8_t  nd_opt_landmark_plen;
        uint8_t  nd_opt_landmark_flags;
        uint32_t nd_opt_landmark_reserved;
        struct in6_addr nd_opt_landmark_prefix;
};



#define ND_OPT_LMARK_FLAG_YES  0x80
#define ND_OPT_LMARK_FLAG_NO   0x40

#endif /* ND_OPT_LANDMARK*/


#ifndef ND_OPT_DNA
#define ND_OPT_DNA 0x20

struct nd_opt_dna_hdr{
        uint8_t  nd_opt_dna_type;
        uint8_t  nd_opt_dna_len;
        uint8_t  nd_opt_dna_prefonlink;
        uint8_t  nd_opt_dna_reserved1;
        uint32_t nd_opt_dna_reserved2;
};

#endif /* ND_OPT_DNA */


#ifndef ND_RA_FLAG_COMPLETERA
#define ND_RA_FLAG_COMPLETERA       0x02
#endif /* ND_RA_FLAG_COMPLETERA */




#ifndef MAX_DNA_PREFIX_LIFETIME
#define MAX_DNA_PREFIX_LIFETIME 1800 /* seconds */
#endif /* MAX_DNA_PREFIX_LIFETIME*/


#endif /* DNA_H */
